local mod = MorgDKP2:NewModule("Percent")
local L = LibStub("AceLocale-3.0"):GetLocale("MorgDKP2")
local media = LibStub("LibSharedMedia-3.0", true)
local BC = LibStub("LibBabble-Class-3.0"):GetLookupTable()

local mdkp = MorgDKP2

--locals
local LL = LibStub("AceLocale-3.0"):NewLocale("Percent", "enUS", true)
	
if LL then
	LL["Enable"] = true
	LL["Percent DKP"] = true
	LL["Items will cost a percentage of the members total DKP."] = true
	LL["%s received %s for %s DKP"] = true
	LL["Percent cost"] = true
	LL["Percent take"] = true
	LL["When using the percent DKP system this option enables TAKE looting.  This means if the winning member rolled TAKE he will not be charged x% DKP he will instead be charged the base price of the item (Set using original itempoints."] = true
end

local LL = LibStub("AceLocale-3.0"):GetLocale("Percent")

mod.modName = LL["Percent DKP"]
mod.modref = "Percent"

local Player = UnitName("player")
local floor = math.floor
local fmt = string.format
local db

local defaults = { 
	profile = {
		percent = 50,
		percenttake = nil,
	},
}

local options = {
		type = "group",
		handler = mod,
		name = LL["Percent DKP"],
		desc = LL["Percent DKP"],
		order = 380,
		args = {
			enable = {
				type = "toggle",
				name = LL["Enable"],
				desc = LL["Items will cost a percentage of the members total DKP."],
				get = function() return mdkp.db.profile.modules.Percent end,
				set = 	function(info, v) 
						mdkp.db.profile.modules.Percent = v
						if v then 
							mod:DKPChange(mod.modName)
						else 
							mod:Disable()
							mdkp.db.profile.currDKP = nil 	
						end
					end,
				order = 5
			},
			percent = {
				type = "range",
				name = LL["Percent cost"],
				get = function() return mod.db.profile.percent end,
				set = function(info, v) mod.db.profile.percent = v end,
				min = 1, 
				max = 100, 
				step = 1,
				hidden = function() return not mdkp.db.profile.modules.Percent end,
				order = 10
			},
			ptake = {
				type = "toggle",
				name = LL["Percent take"],
				desc = LL["When using the percent DKP system this option enables TAKE looting.  This means if the winning member rolled TAKE he will not be charged x% DKP he will instead be charged the base price of the item (Set using original itempoints."],
				get = function() return mod.db.profile.percenttake end,
				set = function(info, v) mod.db.profile.percenttake = v end,
				hidden = function() return not mdkp.db.profile.modules.Percent end,
				order = 20
			},
		},
}

function mod:GetOptions()
	return options
end

function mod:IsDKP()
	return true
end

function mod:GetName()
	return mod.modName, mod.modref
end

function mod:OnInitialize()
	self.db = mdkp.db:RegisterNamespace("Percent", defaults)
	
end

function mod:OnEnable()
	db = mdkp.db.profile
	db.moduleON["Percent"] = true
	
end

function mod:OnDisable()
	db.moduleON["Percent"] = nil
end

function mod:GetPlayerPoints(name, POOL)
	return db.info[name][POOL].points
end

function mod:GetItemValue(itemid, player, POOL)
	local points = self:GetPlayerPoints(player, POOL)
	local itempoints = floor((points * self.db.profile.percent/100)  + 0.5)
	if self.db.profile.percenttake then
		if mdkp.querytooltips[itemid] then
			for  i,v in pairs(mdkp.querytooltips[itemid]) do
				if v[1].n == player then
					if v[2].n == L["TAKE"] then itempoints = mdkp.origitempoints[itemid]  end
					break
				end
			end
		end
	end
	
	return itempoints
end

function mod:ItemRecorded(id, looter, POOL, points, itempoints, link)
	points = points - itempoints
	db.info[looter][POOL].points = points
	db.info[looter][POOL].spent = db.info[looter][POOL].spent + itempoints
	db.info[looter].raidloot = 1
	db.info[looter].lastupdate = self:GetServerTime()
	self:out(fmt(LL["%s received %s for %s DKP"], looter, link, itempoints)) 
end
